import { Product } from 'ssn';

function getHttpContents(url: string): Promise<Buffer> {
  return new Promise(function(resolve) {
    setTimeout(resolve.bind(null, new Buffer('foobar')), 1000 + Math.round(Math.random() * 3000));
  });
}
function extractFirstFile(buffer: Buffer): any { /* do nothing */ }
function verifyManifestFile(file: any) { /* do nothing */ }
function parseManifest(file: any) { /* do nothing */ }

export default async function* getManifest(product: Product) {
  const contents = await getHttpContents(`http://manifest.swtor.com/patch/${product}.patchmanifest`);
  yield { step: 'GOTTEN_HTTP' };

  const file = extractFirstFile(contents);
  yield { step: 'FILE_EXTRACTED' };

  verifyManifestFile(file);
  yield { step: 'FILE_VERIFIED' };

  const manifest = parseManifest(file);
  yield { step: 'FILE_PARSED' };

  //TODO: write new version into database
}
